/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: Fact.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _TOPS_FACT_HPP_
#define _TOPS_FACT_HPP_

#include "tops/object/Object.hpp"

namespace tops {

	class AttributesOfFact;
	typedef boost::shared_ptr<AttributesOfFact> AttributesOfFactPtr;

	/**
	 * 事実です。
	 *
	 * @author トゥイー
	 */
	class Fact : public Object {
	private:
		/**
		 * 属性列です。
		 */
		AttributesOfFactPtr m_attributes;

	public:
		/**
		 * 属性の無い事実を構築します。
		 *
		 * @param name 名前を指定します。
		 */
		Fact(const std::string& name);

		/**
		 * 事実を構築します。
		 *
		 * @param name 名前を指定します。
		 * @param attributes 属性列を指定します。
		 */
		Fact(const std::string& name, const AttributesOfFactPtr& attributes) :
		Object(name), m_attributes(attributes) {
		}

	public:
		/**
		 * 属性列を取得します。
		 */
		AttributesOfFact& getAttributes() const {
			return *m_attributes;
		}

	public:
		/**
		 * 等値判断を行います。
		 *
		 * @param fact 等値判断対象となる事実を指定します。
		 * @return 等値ならtrueを、そうじゃないならfalseを返します。
		 */
		bool equals(const Fact& fact) const;

	public:
		/**
		 * ストリームに出力します。
		 */
		void print(std::ostream& stream) const;
	};

}  // namespace tops

#endif
